depot.copy(SCRIPT_PATH+'/opsisetuplib.py', '/tmp')
exec(open('/tmp/opsisetuplib.py').read())

logger.notice(u"##############################################################")
productVersion =''
packageVersion =''
unattendTemplateMd5 = 'UNATTENDMD5SUM'
for i in range(len(productOnDepots)):
    if (productOnDepots[i]['productId'] == productId):
        productVersion = productOnDepots[i]['productVersion']
        packageVersion = productOnDepots[i]['packageVersion']
    break
logger.notice(u"Installing Product: %s_%s-%s on %s" % (productId,productVersion,packageVersion,clientId))
scriptMessageSubject.setMessage(u"Installing Product: %s_%s-%s on %s" % (productId,productVersion,packageVersion,clientId))

if (str(productProperties.get('destroy_partition_table', 'false')).lower() == 'true'):
    first_disk = execute(f"{which('sfdisk')} --no-reread -s | head -1", ignoreExitCode=[1])[0].split(":")[0]
    if first_disk:
        execute(f"{which('sgdisk')} --zap-all {first_disk}")
        execute(f"{which('sync')}")
    else:
        raise RuntimeError("No harddisks found!")
    
# Get first harddisk
disk = getHarddisks()[0]

diskDevicePath = '%s' % disk.device
execute('hdparm -I %s' % diskDevicePath)

if isRotationalDisk(disk.device):
    # Get number of iterations from config
    iterations = productProperties.get('iterations')
    
    # Get partition to delete from config
    partition = productProperties.get('partition')
    if partition=='0':
        logger.notice(u'The whole disk will be wiped')
        partition = ''
    for x in range(int(iterations)):
        wipeNo = x + 1
        logger.notice(u' Wiping disk for the %s of %s times' % (wipeNo, iterations))
        ui.getMessageBox().addText('Wiping disk for the %s of %s times \n' % (x, iterations))
        try:
            execute('dd if=/dev/zero of=%s%s bs=1M 2>/dev/null' % (diskDevicePath, partition))
        except RuntimeError:
            pass
    # Shred disk / partition
    #disk.shred(partition = int(partition), iterations=int(iterations)).decode()
else:
    logger.notice(u'disk: %s is a ssd/nvme' % diskDevicePath)
    if 'nvme' in diskDevicePath:
        formatNvmeSupported = True
        if not bootimageVersion or (int(bootimageVersion) < 20210318):
            raise Exception(u'The nvme format feature requires opsi-linux-bootimage version >= 20210318')
        output = execute('nvme id-ctrl -H %s ' % diskDevicePath)
        for line in output:
            if "Format NVM Not Supported" in line:
                formatNvmeSupported = False
                logger.error('This NVME does not support the format feature!')
                logger.error('Running sgdisk --zap-all anyway, but no secure format is run')
                execute('sgdisk --zap-all %s' % diskDevicePath)
        if formatNvmeSupported:
            execute('rtcwake -m mem -s 10')
            logger.notice("FORMAT LINE: %s" % line)
            execute('sgdisk --zap-all %s' % diskDevicePath)
            try:
                execute('nvme format -s1 %s' % diskDevicePath)
            except RuntimeError as nvmeError:
                logger.error("Something went wrong: %s" % nvmeError)
                logger.error("nvme format command was not successfull")
    else:
        if not bootimageVersion or (int(bootimageVersion) < 20210318):
            raise Exception(u'The SSD Enhanced Erase feature requires opsi-linux-bootimage version >= 20210318')
        execute('hdparm -I %s' % diskDevicePath)
        output = execute('hdparm -I %s' % diskDevicePath)
        enhancedEraseExists = False
        for line in output:
            if 'frozen' in line:
                if 'not' in line:
                    logger.notice(u'Device %s is not frozen, continuing' % diskDevicePath)
                else:
                    logger.notice(u'Device %s is frozen, suspending and resuming' % diskDevicePath)
                    execute('rtcwake -m mem -s 20')
                    output2 = execute('hdparm -I %s' % diskDevicePath)
                    for line in output2:
                        if 'frozen' in line:
                            if 'not' in line:
                                logger.notice(u'Device %s is not frozen, continuing' % diskDevicePath)
                            else:
                                logger.error(u'Device %s is still frozen. SecureErase will probably fail' % diskDevicePath)
                    
            if 'supported: enhanced erase' in line:
                enhancedEraseExists = True
                if 'not' in line:
                    logger.error('Enhanced Erase is not supported, deleting partitions with sgdisk')
                    execute('sgdisk --zap-all %s' % diskDevicePath)
                else:
                    logger.notice(u'enhanced erase is supported, performing')
                    execute('hdparm --user-master u --security-set-pass linux123 %s' % diskDevicePath)
                    output3 = execute('time hdparm --user-master u --security-erase linux123 %s' % diskDevicePath)
                    for line in output3:
                        if 'SG_IO: bad/missing sense data' in line:
                            logger.error("Secure Erase failed, most probably because the device is locked. Fallback to SGDisk.")
                            execute('sgdisk --zap-all %s' % diskDevicePath)
                    output4 = execute('hdparm -I %s' % diskDevicePath)
                    for line2 in output4:
                        if 'locked' in line2:
                            if 'not' in line2:
                                logger.notice('drive %s does not seem to be locked' % diskDevicePath)
                            else:
                                logger.notice('drive %s seems to be locked, trying to unlock' % diskDevicePath)
                                execute('hdparm --security-disable linux123')
        if not enhancedEraseExists:
                logger.error('SSD enhanced erase feature does not seem to be supported, no secure wipe performed')
                execute('sgdisk --zap-all %s' % diskDevicePath)
        execute('hdparm -I %s' % diskDevicePath)
       
# Set product installation status
backend.setProductInstallationStatus(productId, fqdn, 'not_installed')
productOnClient.setActionResult('successful')
productOnClient.setLastAction('setup')

setupAfterInstall = productPropertyValues.get('netbootafterinstall', '')
if setupAfterInstall:
    for setupProduct in setupAfterInstall:
        setupProduct = setupProduct.strip()
        if u',' in setupProduct:
            # This is the workaround for a bug where the list of
            # images will become a comma-seperated string instead of
            # a list of strings.
            for key_part in setupProduct.split(u','):
                if not (key_part in setupAfterInstall):
                    setupAfterInstall.append(key_part)
            setupAfterInstall.remove(setupProduct)
            backend.productPropertyState_create(productId = productId ,propertyId = 'netbootafterinstall',objectId = clientId,values = setupAfterInstall)
    for setupProduct in setupAfterInstall:
        setupProduct = setupProduct.strip()
        if setupProduct != '':
            logger.notice(u"Set to setup %s" % (setupProduct) )
            backend.setProductActionRequest(productId=setupProduct, clientId=clientId, actionRequest='setup')
    reboot()
else:
    # Halt
    halt()
